//S. Ganceanu 50
#include <stdio.h>
#include <string.h>

const long MAXN = 10;

long lin_labels[MAXN], col_labels[MAXN];
long print_first_sol, N, nsol;
long mat[MAXN][MAXN], sol[2 * MAXN], vec[2 * MAXN];

void read_data() {
  long i;
  FILE *f = fopen("magic.in", "rt");
  long x;
  fscanf(f, "%ld\n%ld\n", &x, &N);
  print_first_sol = (x == 2);
  for (i = 0; i < N; ++i) {
    fscanf(f, "%ld", lin_labels + i);
    --lin_labels[i];
  }
  for (i = 0; i < N; ++i) {
    fscanf(f, "%ld", col_labels + i);
    --col_labels[i];
  }
  fclose(f);
}

void solve() {
  long N2 = N * N;
  long cfg, i, j;
  for (cfg = 0; cfg < (1l << N2); ++cfg) {
    for (i = 0; i < N; ++i) {
      for (j = 0; j < N; ++j) {
        long tmp = i * N + j;
        mat[i][j] = (cfg & (1l << tmp)) != 0;
      }
    }
    for (i = 0; i < N; ++i) {
      long current = 0;
      for (j = N - 1; j >= 0; --j) {
        current += mat[i][j] * (1l << (N - 1 - j));
      }
      vec[lin_labels[i]] = current;
    }
    for (j = 0; j < N; ++j) {
      long current = 0;
      for (long i = N - 1; i >= 0; --i) {
        current += mat[i][j] * (1l << (N - 1 - i));
      }
      vec[col_labels[j]] = current;
    }
    long ok = 1;
    for (i = 1; i < 2 * N; ++i) {
      if (vec[i] <= vec[i - 1]) {
        ok = 0;
      }
    }
    if (ok) {
      ++nsol;
      if (nsol == 1) {
        memcpy(sol, vec, sizeof(vec));
      } else {
        long cmp = 0;
        for (i = 0; i < 2 * N; ++i) {
          if (sol[i] != vec[i]) {
            cmp = sol[i] - vec[i];
            break;
          }
        }
        if (cmp > 0) {
          memcpy(sol, vec, sizeof(vec));
        }
      }
    }
  }
}

void write_data() {
  long i, j;
  FILE *f = fopen("magic.out", "wt");
  if (print_first_sol) {
    for (i = 0; i < 2 * N; ++i) {
      for (j = 0; j < N; ++j) {
        if (sol[i] & (1l << (N - 1 - j))) {
          fprintf(f, "9");
        } else {
          fprintf(f, "1");
        }
      }
    }
  } else {
    fprintf(f, "%ld", nsol);
  }
  fprintf(f, "\n");
}

int main() {
  read_data();
  solve();
  write_data();
  return 0;
}

