// Buruiana Filip - 100 de puncte

#include <stdio.h>
#include <stdlib.h>

#define MAX 14
#define MaxQueue 3432 // combinari de 7 luate cate 14
#define li long int

typedef struct { int x, y; } point;

int N, D;
unsigned char dist[1<<MAX], valid[1<<MAX];
int q[MaxQueue], up[MaxQueue], chx[MaxQueue], chy[MaxQueue];
point P[MAX];

li sqr(int X)
{ return (li)X * X; }

int bit(int X, int nr_bit)
{ return (X & (1<<nr_bit)) != 0; }

int canChange(int i, int j)
{
    return (sqr(P[i].x-P[j].x)+sqr(P[i].y-P[j].y) <= (li)D * D);
}

int semn(int p1, int p2, int p3)
{
    li A = P[p1].y-P[p2].y, B = P[p2].x-P[p1].x, 
       C = (li)P[p1].x * P[p2].y - (li)P[p2].x * P[p1].y;
    li E = A * P[p3].x + B * P[p3].y + C;   
    
    if (E < 0)
        return -1;
    if (E > 0)
        return +1;
    return 0;
}

int separated(int config, int p1, int p2)
{
    int i, semn_b = -2;
    
    for (i = 0; i < N; ++i)
    {
        if (i == p1 || i == p2)
            continue;
        if (semn_b == -2)
        {
            if (bit(config, i))
                semn_b = semn(p1, p2, i);
            else
                semn_b = -semn(p1, p2, i);
            continue;
        }
        if (bit(config, i) && semn_b != semn(p1, p2, i))
            return 0;
        if (!bit(config, i) && semn_b == semn(p1, p2, i))
            return 0;
    }
    return 1;
}

int path[128]; // vectorul solutie
void printSolution(int config, int poz)
{
    printf("%d\n", dist[config]);
    
    int c, n = 0, i1, i2;
    for (c = poz; c != 0; c = up[c])
        path[++n] = c;
    for (c = n; c; --c)
    {
        i1 = chx[path[c]];
        i2 = chy[path[c]];
        printf("%d %d %d %d\n", P[i1].x, P[i1].y, P[i2].x, P[i2].y);
    }
    exit(0);
}

int main()
{
    int i, j, k, nr, qr = 0, ql = 0;
    int config = 0, newconf = 0;
    char tip;
    
    freopen("volei.in", "r", stdin);
    freopen("volei.out", "w", stdout);
    
    scanf("%d %d", &N, &D);
    N *= 2;
    for (i = 0; i < N; ++i)
    {
        scanf("%d %d %c", &P[i].x, &P[i].y, &tip);
        if (tip == 'B')
            config += (1<<i);
    }
    for (i = 0; i < (1<<N); ++i)
        dist[i] = N*N;
    dist[config] = 0;
    q[ql] = config;
    
    for (config = 0; config < (1<<N); ++config)
    {
        valid[config] = 0;
        for (j = 0, nr = 0; j < N; ++j)
            nr += bit(config, j);
        if (nr != N/2)
            continue;
        for (j = 0; j < N && !valid[config]; ++j)
            if (!bit(config, j))
                for (k = 0; k < N && !valid[config]; ++k)
                    if (bit(config, k))
                        valid[config] = separated(config, j, k);
    }
    
    if (valid[q[0]])
    {
        printf("0\n");
        return 0;
    }
    for (; qr <= ql; ++qr)
    {
        config = q[qr];

        for (j = 0; j < N; ++j)
            if (!bit(config, j))
            {
                for (k = 0; k < N; ++k)
                {
                    if (bit(config, k) && canChange(j, k))
                    {
                        newconf = config-(1<<k)+(1<<j);
                        if (dist[config] + 1 < dist[newconf])
                        {
                            q[++ql] = newconf;
                            dist[newconf] = dist[config] + 1;
                            chx[ql] = k; chy[ql] = j;
                            up[ql] = qr;
                            if (valid[newconf])
                                printSolution(newconf, ql);
                        }
                    }
                }
            }
    }

    printf("-1\n");

    return 0;
}
