#include <fstream>
#include <algorithm>

using namespace std;

#define MAXN 100010
#define MAXX 262144
#define ll long long
#define INF 10000000000000000LL

int N, K, L;
int X, Y, V, Value, Med;
int A[MAXN], P[MAXN], W[MAXN];
int C[MAXX];
ll Sum[MAXX];
ll Sol;

inline int cmp(int x, int y)
{
	return A[x] < A[y];
}

void update(int p, int r, int nod)
{
	if (p == r)
	{
		C[nod] = V;
		Sum[nod] = Value;
	}
	else {
			 int q = (p+r) / 2;

			 if (X <= q) update(p, q, nod*2);
			 else update(q+1, r, nod*2+1);

			 Sum[nod] = Sum[nod*2] + Sum[nod*2+1];
			 C[nod] = C[nod*2] + C[nod*2+1];
		 }
}

int locate(int p, int r, int nod)
{
	if (p == r) return p;

	int q = (p+r) / 2;

	if (V <= C[nod*2]) return locate(p, q, nod*2);

	V -= C[nod*2];
	return locate(q+1, r, nod*2+1);
}

ll query(int p, int r, int nod)
{
	if (X <= p && r <= Y) return Sum[nod];
	else {
			 int q = (p+r) / 2;
			 ll rez = 0;

			 if (X <= q) rez = query(p, q, nod*2);
			 if (q+1 <= Y) rez += query(q+1, r, nod*2+1);

			 return rez;
		 }
}

int main()
{
	ifstream fin("pikachu.in");
	ofstream fout("pikachu.out");

	int i;
	ll S;

	fin >> N >> K;

	for (i = 1; i <= N; i++) 
	{
		fin >> A[i];
		P[i] = i;
	}

	sort(P+1, P+N+1, cmp);

	for (i = 1; i <= N; i++) W[P[i]] = i;

	for (L = 1; L < N; L <<= 1);

	Sol = INF;

	for (i = 1; i <= N; i++)
	{
		X = W[i];
		V = 1, Value = A[i];
		update(1, L, 1);

		if (i - K > 0)
		{
			X = W[i-K];
			V = 0, Value = 0;
			update(1, L, 1);
		}

		if (i - K >= 0)
		{
			V = K/2 + 1;
			Med = locate(1, L, 1);

			X = 1, Y = Med - 1;
			S = (1LL * A[P[Med]] * (K/2)) - query(1, L, 1);
			
			X = Med + 1, Y = N;
			S += query(1, L, 1) - (1LL * A[P[Med]]*(K-(K/2+1)));

			Sol = min(Sol, S);
		}
	}

	fout << Sol << endl;

	return 0;
}
