
/*
Autor: Catalin-Stefan Tiseanu
Punctaj: 
Complexitate: O(N * K)
*/

#include <cstdio>
#include <algorithm>
#include <vector>
#include <iostream>
#include <cmath>

using namespace std;

#define MAX_N (1<<17)

int N, K, A[MAX_N], buf[MAX_N];

int main() {
  freopen("pikachu.in", "r", stdin);
  freopen("pikachu.out", "w", stdout);  

  scanf("%d %d", &N, &K);
  for ( int i = 1; i <= N; ++i )
    scanf("%d", A + i );
  
  long long best_cost = (1LL<<62);
  
  for ( int i = K; i <= N; ++i ) {
    long long cur_cost = 0, med;
    int left = i - K + 1;
    
    for ( int j = left; j <= i; ++j )
      buf[ j - left + 1 ] = A[j];
      
    nth_element(buf + 1, buf + (K+1)/2, buf + K + 1 );
    med = buf[(K+1)/2];
        
    for ( int j = i - K + 1; j <= i; ++j )
      cur_cost += abs( A[j] - med );
  
    if( cur_cost < best_cost )
      best_cost = cur_cost;
  }
  
  cout << best_cost << endl;
  
  return 0;    
}
